<?php
namespace Geral\Repositories;

class Serienf extends \Doctrine\ORM\EntityRepository
{


    /**
     * Consulta serie padrao por filial
     *
     * @static
     * @param integer $nrorg    Numero da organizacao
     * @param integer $cdfilial Codigo da filial
     * @return string  $sql      Resultset
     */
    public static function SeriePadraoPorFilial($nrorg, $cdfilial) {
        $sql = "SELECT S.CDSERIE, S.DSSERIE, S.CDEMPRESA, S.CDINSCESTA, S.CDINSCMUNI,
                       C.IDUTLOCAEMIS, S.CDCTRLNUMENF, C.IDUTFILILCEM
                FROM FILIAL F,
                     SERIENF S
                LEFT JOIN CTRLNUMENF C
                ON  (S.NRORG          = C.NRORG)
                AND (S.CDCTRLNUMENF   = C.CDCTRLNUMENF)
                WHERE (F.NRORG      = $nrorg    )
                AND   (F.CDFILIAL   = $cdfilial )
                AND   (F.CDEMPRESA  = S.CDEMPRESA )
                AND   (F.CDINSCESTA = S.CDINSCESTA)
                AND   (F.CDINSCMUNI = S.CDINSCMUNI)
                AND   (F.CDSERIE    = S.CDSERIE   )";
        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);

        return $result[0];
    }


    /**
     * Consulta a existencia de intervalos determinados para o local de emissao
     *
     * @static
     * @param integer $nrorg    Numero da organizacao
     * @param integer $cdfilial Codigo da filial
     * @return array  $result   Resultset
     */
    public static function IntervaloLocalEmissao($nrorg, $cdfilial, $cdlocalemissao)
    {
        $sql = "SELECT NRCDFRINI, CDCTRLNUMENF
                FROM SEQNUMELOCA
                WHERE (CDLOCALEMIS  = $cdlocalemissao)
                AND CDCTRLNUMENF IN (SELECT S.CDCTRLNUMENF
                                      FROM FILIAL F, SERIENF S, CTRLNUMENF C
                                      WHERE (F.NRORG   = $nrorg )
                                      AND   (F.CDFILIAL   = $cdfilial )
                                      AND   (F.NRORG      = S.NRORG )
                                      AND   (F.CDEMPRESA  = S.CDEMPRESA )
                                      AND   (F.CDINSCESTA = S.CDINSCESTA)
                                      AND   (F.CDINSCMUNI = S.CDINSCMUNI)
                                      AND   (F.CDSERIE    = S.CDSERIE   )
                                      AND   (S.NRORG          = C.NRORG(+))
                                      AND   (S.CDCTRLNUMENF   = C.CDCTRLNUMENF(+)))";

        $result = \Setforms2\Runtime\Framework::getInstance()->fetchAll($sql);
        return $result[0];
    }

}