function Pag12300_NotasDevolucoesDisponiveis_Controller(General, ScreenService, templateManager, ZhFilterPreferences) {

	this.setReadSelect = function(fieldNative, widgetFiltro, nameField){
		var field = widgetFiltro.getField(nameField);
		if(fieldNative.value() === 'L'){
			field.readOnly = false;
			field.validations = {"required": true};
		} else {
			field.setValue(null);
			delete field.validations;
			field.readOnly = true;
			if (field.widget.currentRow.$error) {
        		field.widget.currentRow.$error[nameField] = [];
    		}
		}
	};

	this.filter = function(widget) {
		var rowFilter = {
			'TPCDFORNECED' : 'T',
			'TPCDFILIORIG' : 'T',
			'TPCDTIPOOPER' : 'T',
			'STATUS'       : 'T'
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
		ZhFilterPreferences.openFilterWidget(widget, rowFilter);
	};

	this.AjustaFiltro = function(rowFilter, preference){
		var widget = templateManager.container.getWidget('pag12300_notas_devolucoes_disponiveis_grid');
		var pos = 0;
		var deletePos = null;
		widget.dataSourceFilter.forEach(function(filter) {
			switch(filter.name){
				case 'DOCINICIAL': filter.value = (rowFilter.DOCINICIAL) ? rowFilter.DOCINICIAL : null;
					break;
				case 'DOCFINAL': filter.value = (rowFilter.DOCFINAL) ? rowFilter.DOCFINAL : null;
					break;
				case 'CDFORNECED': filter.value = (rowFilter.TPCDFORNECED == 'L') ? rowFilter.CDFORNECED.join('_') : '';
					break;
				case 'TPCDFORNECED': filter.value = rowFilter.TPCDFORNECED;
					break;
				case 'CDFILIORIG': filter.value = (rowFilter.TPCDFILIORIG == 'L') ? rowFilter.CDFILIORIG.join('_') : '';
					break;
				case 'TPCDFILIORIG': filter.value = rowFilter.TPCDFILIORIG;
					break;
				case 'CDTIPOOPER': filter.value = (rowFilter.TPCDTIPOOPER == 'L') ? rowFilter.CDTIPOOPER.join('_') : '';
					break;
				case 'TPCDTIPOOPER': filter.value = rowFilter.TPCDTIPOOPER;
					break;
				case 'DATAINI': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.start : null;
					break;
				case 'DATAFIN': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.end : null;
					break;
				case 'STATUS': filter.value = rowFilter.STATUS;
					break;
				case 'DATA': deletePos = pos;
					break;
			}
			pos++;
		});
		if (deletePos){
			widget.dataSourceFilter.splice(deletePos, 1);
		}
	};
	
	this.setRequired = function(widget, nmf1, nmf2){
		var field1 = widget.getField(nmf1);
		var field2 = widget.getField(nmf2);
		if(field1.value() || field2.value()){
			field1.validations.required = true;
			field2.validations.required = true;
		} else {
			delete field1.validations.required;
			delete field2.validations.required;
			if (widget.currentRow.$error) {
        widget.currentRow.$error[nmf1] = [];
        widget.currentRow.$error[nmf2] = [];
      }
		}
	};
	
	

	this.checaDisponibilidade = function(field, valor){
		if(field.value() === 'N' && valor > 0){
			field.setValue('S');
			ScreenService.showMessage('Operação bloqueada. Nota Fiscal de Devolução já foi utilizada.');
		}
	};
	
	this.setaMascCnpjCpfFornecedor = function(widget) {
	    var data = widget.dataSource.data;
	    var inscFormatada;
	    data.forEach(function(value){
	        if(value.NRINSJURFORN.length === 14) inscFormatada = value.NRINSJURFORN.substr(0, 2) + '.' + value.NRINSJURFORN.substr(2, 3) + '.' + value.NRINSJURFORN.substr(5, 3) + '/' + value.NRINSJURFORN.substr(8, 4) + '-' + value.NRINSJURFORN.substr(12, 2);
          else if(value.NRINSJURFORN.length === 11) inscFormatada = value.NRINSJURFORN.substr(0, 3) + '.' + value.NRINSJURFORN.substr(3, 3) + '.' + value.NRINSJURFORN.substr(6, 3) + '-' + value.NRINSJURFORN.substr(9, 2);
          else inscFormatada = null;
          value.NRINSJURFORN = inscFormatada?inscFormatada:value.NRINSJURFORN;
	    });
	};
	
	this.changeHeaderValues = function(widget){
        /*var codigo; 
        var nmempresa = widget.owner.dataSource.data[0].NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "is equal to".concat(codigo).concat(' - ').concat(nmempresa)
        };*/
        
        var filter = widget.e.metadata.filter;
        var newFilter = [];
        //newFilter.push(cdempresa);
        filter.forEach(function(x){
            if(x.value != "é igual a."){
                newFilter.push(x);
            }
        });
        
        var correctFilter = [];
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/é igual a/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/está entre/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
        
        
    };
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Pag12300_NotasDevolucoesDisponiveis_Controller', Pag12300_NotasDevolucoesDisponiveis_Controller);
});